*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\GridDuo\\DRAGDROP.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function EnableDragAndDrop()
*+               Function DisableDragAndDrop()
*+               Function isEnableDragAndDrop()
*+               Function _HMG_DragAndDrop()
*+               Function HMG_ValidControlTypeDragAndDrop()
*+               Function HMG_ValidControlDrag()
*+               Function HMG_ValidControlDrop()
*+               Function HMG_Is_DaD()
*+               Function HMG_Release_DaD()
*+               Function HMG_DaD_Drag()
*+               Function HMG_DaD_Drop()
*+               Function HMG_DaD_Drag_Window()
*+               Function HMG_DaD_Drag_Control()
*+               Function HMG_DaD_Drop_Window()
*+               Function HMG_DaD_Drop_Control()
*+               Function HMG_DaD_DropCellPos()
*+               Function HMG_DaD_DropCellRow()
*+               Function HMG_DaD_DropCellCol()
*+               Function HMG_DaD_DragCellPos()
*+               Function HMG_DaD_DragCellRow()
*+               Function HMG_DaD_DragCellCol()
*+               Function HMG_DaD_Value()
*+               Function HMG_DaD_CellValue()
*+               Function HMG_DaD_DragTreeValue()
*+               Function HMG_DaD_DropTreeValue()
*+               Function HMG_DaD_DragGridValue()
*+               Function HMG_DaD_DropGridValue()
*+               Function HMG_Is_RButtonDaD()
*+               Function HMG_Is_GridHeaderDaD()
*+               Function HMG_Is_ShiftDaD()
*+               Function HMG_DaD_DragControlEnable()
*+               Function HMG_DaD_DropControlEnable()
*+               Function _GetTreeItemValue()
*+               Function _IsTreeItemIDs()
*+               Function _InsertItem()
*+
*+    Reformatted by Click! 2.05.35 on Nov-11-2020 at 11:40 pm
*+
*+--------------------------------------------------------------------

#include <hmg.ch>

#define TVGN_CARET   9
#define TVGN_FIRSTVISIBLE  5
#define TVGN_DROPHILITE 8

MEMVAR _HMG_SYSDATA , _HMG_DAD_DATA

*+--------------------------------------------------------------------
*+
*+    Function EnableDragAndDrop()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION EnableDragAndDrop()

LOCAL nEventIdx
   //  Create Public Array
PUBLIC _HMG_DaD_DATA[ 14 ]

   CREATE EVENT PROCNAME _HMG_DragAndDrop() STOREINDEX nEventIdx
   //EventProcessHMGWindowsMessage (nEventIdx, .T.)
   //EventProcessAllHookMessage ( nEventIdx, .T. )
   _HMG_DaD_DATA[ 1 ] := nEventIdx

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function DisableDragAndDrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION DisableDragAndDrop()

   IF hb_IsArray( _HMG_DaD_DATA ) .AND. _HMG_DaD_DATA[ 1 ] <> Nil
      EventRemove( _HMG_DaD_DATA[ 1 ] )
   ENDIF
   RELEASE _HMG_DaD_DATA
   IF isWindowDefined( _HMG_Drag_Form_ ) .AND. isWindowActive( _HMG_Drag_Form_ )
      DoMethod( '_HMG_Drag_Form_', 'Release' )
   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function isEnableDragAndDrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION isEnableDragAndDrop()

RETURN hb_IsArray( _HMG_DaD_DATA )

*+--------------------------------------------------------------------
*+
*+    Function _HMG_DragAndDrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION _HMG_DragAndDrop()

STATIC nLastMsg, aDragDATA, aCursorChng := {}
LOCAL nHWnd           := EventHWND()
LOCAL nMsg            := EventMSG()
LOCAL nWParam         := EventWPARAM()
LOCAL nLParam         := EventLPARAM()
LOCAL nIndex          := GetControlIndexByHandle( nHWnd )
LOCAL nIndexHeader    := ASCAN( _HMG_SYSDATA[ 5 ], nHWnd )            //determine grid header index
LOCAL cCtrlType       := IF( nIndex > 0, GetControlTypeByIndex( nIndex ), "" )
LOCAL cHeaderType     := IF( nIndexHeader > 0, GetControlTypeByIndex( nIndexHeader ), "" )                                                  //determine grid header type
LOCAL nGridRow, nGridCol, aGridCellData
LOCAL cCtrlName       := "", cFormName := "", i, j, aValue := {}, aRecord := {}, Ret := Nil, xCellValue
LOCAL hDC, BTstruct, hBitmap
LOCAL nhItemMouseOver, nTreeValue, aRect
LOCAL nInsMarkPos,nDropMarkPos

   // IF !hb_IsArray(_HMG_DaD_DATA)
   //   PUBLIC _HMG_DaD_DATA [14]
   //   _HMG_DaD_DATA [1] := EventINDEX ()
   // ENDIF

   IF !isWindowDefined( _HMG_Drag_Form_ )                             //.and. .f.
      i := ASCAN( _HMG_SYSDATA[ 69 ], 'A' )
      IF i > 0 .AND. _HMG_SYSDATA[ 68 ] [ i ]                         //main window is already activated
         DEFINE WINDOW _HMG_Drag_Form_ ;
               AT 0, 0 ;
               WIDTH 100 ;
               HEIGHT 25 ;
               WINDOWTYPE STANDARD ;
               TOPMOST ;
               NOMINIMIZE ;
               NOMAXIMIZE ;
               NOSIZE ;
               NOSYSMENU ;
               NOCAPTION

            @  0,  0 IMAGE _HMD_Drag_Image_ PICTURE "" WIDTH 0 HEIGHT 0 TRANSPARENT

         END WINDOW
         SET WINDOW _HMG_Drag_Form_ TRANSPARENT TO OPAQUE
         DISABLE EVENT OF _HMG_Drag_Form_
      ENDIF
      RETURN Nil
   ENDIF

   /* for test only
if isWindowDefined(Form_1)
setproperty('Form_1','Title', hb_valtostr(nHWnd)+' #'+ cCtrlType+;
         ' @'+hb_valtostr(nIndex)+" nMsg>"+hb_valToStr(nMsg)+" nWParam>"+hb_valToStr(nWParam)+" nLParam>"+hb_valToStr(nLParam))
endif
*/

   IF VALTYPE( aDragDATA ) == "A"
      IF ASCAN( aCursorChng, nHWnd ) == 0
         AADD( aCursorChng, nHWnd )
      ENDIF
      //SetWindowCursor (nHWnd, IF ( aDragDATA [1] == nHWnd, "HMG_DRAGUP", "HMG_DRAGDOWN" ) )   //change mouse cursor
      GetControlNameByHandle( nHWnd, @cCtrlName, @cFormName )
      IF aDragDATA[ 7 ]                                               //drag grid header
         SetWindowCursor( nHWnd, IF( ( cHeaderType == 'GRID' .OR. cHeaderType == 'MULTIGRID' ) .AND. HMG_ValidControlDrop( cFormName, cCtrlName ), IDC_UPARROW, IDC_NO ) )                                        //change mouse cursor
      ELSE
         SetWindowCursor( nHWnd, IF( HMG_ValidControlTypeDragAndDrop( cCtrlType ) .AND. HMG_ValidControlDrop( cFormName, cCtrlName ), IDC_UPARROW, IDC_NO ) )                                                     //change mouse cursor
      ENDIF
      IF isWindowDefined( _HMG_Drag_Form_ )
         SetProperty( '_HMG_Drag_Form_', 'Row', GetCursorPos() [ 1 ] + 5 )
         SetProperty( '_HMG_Drag_Form_', 'Col', GetCursorPos() [ 2 ] + 5 )

         IF cCtrlType == "TREE"                                       //Drop hilite
            nhItemMouseOver := TREEVIEW_HITTEST( nHWnd, GetCursorRow() - GetWindowRow( nHWnd ), GetCursorCol() - GetWindowCol( nHWnd ) )

            //IF NumAnd(nWParam, MK_SHIFT) == MK_SHIFT   //flickering :( //MK_SHIFT bit is set (Shift key is pressed)
            IF HMG_VirtualKeyIsPressed( VK_LSHIFT ) .OR. HMG_VirtualKeyIsPressed( VK_RSHIFT )
               nInsMarkPos := nhItemMouseOver
               nDropMarkPos := NIL
            ELSE
               nInsMarkPos := NIL
               nDropMarkPos := nhItemMouseOver
            ENDIF

            TreeView_SetInsertMark( nHWnd, nInsMarkPos, .T. )

            IF VALTYPE( _HMG_SYSDATA[ 40 ] [ nIndex ] [ 2 ] /* DynamicForeColor */ ) == "B"
               TreeView_Select( nHWnd, nDropMarkPos, TVGN_CARET )
            ELSE
               TreeView_Select( nHWnd, nDropMarkPos, TVGN_DROPHILITE )                                                                      //TVGN_DROPHILITE don't works with defined DynamicForeColor
            ENDIF
         ENDIF

      ENDIF

   ELSEIF LEN( aCursorChng ) > 0 .AND. nMsg == WM_MOUSEMOVE .AND. NumAnd( nWParam, MK_LBUTTON + MK_RBUTTON ) == 0
      FOR EACH i IN aCursorChng
         SetWindowCursor( i, IDC_ARROW )                              //reastore all changed mouse cursor
      NEXT
      IF isWindowDefined( _HMG_Drag_Form_ )
         DoMethod( '_HMG_Drag_Form_', 'Hide' )
      ENDIF
      aCursorChng := {}
      HMG_Release_DaD()
   ENDIF

   IF !HMG_ValidControlTypeDragAndDrop( cCtrlType ) .AND. cHeaderType <> 'GRID' .AND. cHeaderType <> 'MULTIGRID'
      // IF nMsg == WM_MOUSEMOVE .AND. nWParam # MK_LBUTTON .AND. nWParam # MK_RBUTTON .AND. VALTYPE(aDragDATA) == "A" //canceled drag
      IF nMsg == WM_MOUSEMOVE .AND. NumAnd( nWParam, MK_LBUTTON + MK_RBUTTON ) == 0 .AND. VALTYPE( aDragDATA ) == "A"                       //canceled drag
         IF isWindowDefined( _HMG_Drag_Form_ )
            DoMethod( '_HMG_Drag_Form_', 'Hide' )
         ENDIF
         HMG_Release_DaD()
         aDragDATA := Nil                                             //release drag data
         FOR EACH i IN aCursorChng
            SetWindowCursor( i, IDC_ARROW )                           //reastore all changed mouse cursor
         NEXT
         aCursorChng := {}
      ENDIF
      RETURN Nil
   ELSE
      DO CASE

            //MouseDrag detect on grid header and not stored drag data
         CASE ( cHeaderType == 'GRID' .OR. cHeaderType == 'MULTIGRID' ) .AND. ;
                   nMsg == WM_MOUSEMOVE .AND. nLastMsg == WM_MOUSEMOVE .AND. ;
                   NumAnd( nWParam, MK_LBUTTON + MK_RBUTTON ) # 0 .AND. aDragDATA == Nil

            IF NumAnd( nWParam, MK_LBUTTON ) == MK_LBUTTON            //Left Button not supported (event on headclick start processing)
               RETURN Nil
            ENDIF
            GetControlNameByHandle( GetControlHandleByIndex( nIndexHeader ), @cCtrlName, @cFormName )

            IF !HMG_ValidControlDrag( cFormName, cCtrlName )          //Control not enabled to drag
               IF ASCAN( aCursorChng, nHWnd ) == 0
                  AADD( aCursorChng, nHWnd )
               ENDIF
               SetWindowCursor( nHWnd, IDC_NO )                       //change mouse cursor
               RETURN Nil
            ENDIF

            aGridCellData := _GetGridCellData( nIndexHeader )         //_GetGridCellData (nIndex) /* { CellRowClicked, CellColClicked } */

            nGridRow := aGridCellData[ 1 ]                            //Row of Grid cell
            nGridCol := aGridCellData[ 2 ]                            //Col of Grid cell

            hBitmap := BT_BitmapCaptureClientArea( cFormName, ;
                                                   aGridCellData[ 3 ] - aGridCellData[ 6 ], ;
                                                   aGridCellData[ 4 ], ;
                                                   IF( aGridCellData[ 5 ] > 100, 100, aGridCellData[ 5 ] ), ;
                                                   IF( aGridCellData[ 6 ] > 25, 25, aGridCellData[ 6 ] ) )

            IF nGridCol > 0                                           //Dragged from not empty header col

               //SendMessage (nHWnd, 0x0204, MK_RBUTTON, nLParam)

               aDragDATA := { nHWnd, ;
                              {}, ;
                              Nil, ;
                              { cFormName, cCtrlName }, ;
                              { nGridRow, nGridCol }, ;
                              nWParam, ;
                              .T. }
               //store drag data:
               //[1] handle of grid "from"
               //[2] empty data array
               //[3] nil data
               //[4] Form and Control from name
               //[5] cell dragged
               //[6] nWParam (Left OR Right Button Dragged)
               //[7] Drag Header
            ENDIF

            IF isWindowDefined( _HMG_Drag_Form_ ) .AND. aDragDATA <> Nil
               SetProperty( '_HMG_Drag_Form_', 'Row', GetCursorPos() [ 1 ] + 5 )
               SetProperty( '_HMG_Drag_Form_', 'Col', GetCursorPos() [ 2 ] + 5 )
               //hDC := BT_CreateDC (hBitmap, BT_HDC_BITMAP, @BTstruct)
               //BT_DeleteDC (BTstruct)
               BT_HMGSetImage( '_HMG_Drag_Form_', '_HMD_Drag_Image_', hBitmap, .T. )
               SetProperty( '_HMG_Drag_Form_', 'WIDTH', BT_BitmapWidth( hBitmap ) )
               SetProperty( '_HMG_Drag_Form_', 'HEIGHT', BT_BitmapHeight( hBitmap ) )
               DoMethod( '_HMG_Drag_Form_', 'Show' )
            ENDIF
            BT_BitmapRelease( hBitmap )

            RETURN Nil

            //MouseDrag detect on other supported control (not grid header) and not stored drag data
            // CASE nMsg == WM_MOUSEMOVE .AND. nLastMsg == WM_MOUSEMOVE .AND. ;
            //   ( nWParam == MK_LBUTTON .OR. nWParam == MK_RBUTTON ) .AND. aDragDATA == Nil
         CASE nMsg == WM_MOUSEMOVE .AND. nLastMsg == WM_MOUSEMOVE .AND. ;
                    NumAnd( nWParam, MK_LBUTTON + MK_RBUTTON ) # 0 .AND. aDragDATA == Nil

            GetControlNameByHandle( nHWnd, @cCtrlName, @cFormName )

            IF !HMG_ValidControlDrag( cFormName, cCtrlName )          //Control not enabled to drag
               IF ASCAN( aCursorChng, nHWnd ) == 0
                  AADD( aCursorChng, nHWnd )
               ENDIF
               SetWindowCursor( nHWnd, IDC_NO )
               RETURN Nil
            ENDIF

            DoMethod( cFormName, cCtrlName, "SetFocus" )
            DO CASE
               CASE cCtrlType == "GRID"                               //GRID
                  aGridCellData := _GetGridCellData( nIndex )         //_GetGridCellData (nIndex) /* { CellRowClicked, CellColClicked } */
                  hBitmap := BT_BitmapCaptureClientArea( cFormName, ;
                                                         aGridCellData[ 3 ], ;
                                                         aGridCellData[ 4 ], ;
                                                         IF( aGridCellData[ 5 ] > 100, 100, aGridCellData[ 5 ] ), ;
                                                         IF( aGridCellData[ 6 ] > 25, 25, aGridCellData[ 6 ] ) )

                  nGridRow := aGridCellData[ 1 ]                      //Row of Grid cell
                  nGridCol := aGridCellData[ 2 ]                      //Col of Grid cell
                  IF nGridRow > 0                                     //Dragged from not empty row
                     FOR i = 1 TO GetProperty( cFormName, cCtrlName, "ColumnCOUNT" )
                        AADD( aRecord, GetProperty( cFormName, cCtrlName, "CellEx", nGridRow, i ) )
                     NEXT i
                     AADD( aValue, aRecord )
                     aRecord := {}
                     xCellValue := GetProperty( cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )

                     aDragDATA := { nHWnd, ;
                                    aValue, ;
                                    xCellValue, ;
                                    { cFormName, cCtrlName }, ;
                                    { nGridRow, nGridCol }, ;
                                    nWParam, ;
                                    .F. }
                     //store drag data:
                     //[1] handle of grid "from"
                     //[2] row data
                     //[3] cell data
                     //[4] Form and Control from name
                     //[5] cell dragged
                     //[6] nWParam (Left OR Right Button Dragged)
                     //[7] Drag Header
                  ENDIF

               CASE cCtrlType == "MULTIGRID"                          //GRID MULTISELECT  GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/)

                  aGridCellData := _GetGridCellData( nIndex )         //_GetGridCellData (nIndex) /* { CellRowClicked, CellColClicked } */
                  hBitmap := BT_BitmapCaptureClientArea( cFormName, ;
                                                         aGridCellData[ 3 ], ;
                                                         aGridCellData[ 4 ], ;
                                                         IF( aGridCellData[ 5 ] > 100, 100, aGridCellData[ 5 ] ), ;
                                                         IF( aGridCellData[ 6 ] > 25, 25, aGridCellData[ 6 ] ) )

                  nGridRow := aGridCellData[ 1 ]                      //Row of Grid cell
                  nGridCol := aGridCellData[ 2 ]                      //Col of Grid cell

                  IF LEN( GetProperty( cFormName, cCtrlName, "VALUE" ) ) == 0                                                               //Not selected, drag one row
                     IF nGridRow > 0                                  //Dragged from not empty row
                        FOR i = 1 TO GetProperty( cFormName, cCtrlName, "ColumnCOUNT" )
                           AADD( aRecord, GetProperty( cFormName, cCtrlName, "CellEx", nGridRow, i ) )
                        NEXT i
                        AADD( aValue, aRecord )
                        aRecord := {}
                        xCellValue := GetProperty( cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )
                     ENDIF
                  ELSE
                     FOR j = 1 TO LEN( GetProperty( cFormName, cCtrlName, "VALUE" ) )
                        FOR i = 1 TO GetProperty( cFormName, cCtrlName, "ColumnCOUNT" )
                           AADD( aRecord, GetProperty( cFormName, cCtrlName, "CellEx", GetProperty( cFormName, cCtrlName, "VALUE" ) [j], i ) )
                        NEXT i
                        AADD( aValue, aRecord )
                        aRecord := {}
                     NEXT j
                     IF nGridRow > 0
                        xCellValue := GetProperty( cFormName, cCtrlName, "CellEx", nGridRow, nGridCol )                                     //real cell dragged
                     ELSE
                        xCellValue := GetProperty( cFormName, cCtrlName, "CellEx", GetProperty( cFormName, cCtrlName, "VALUE" ) [1], 1 )    //1-st cell of 1-st selected row
                     ENDIF
                  ENDIF

                  IF LEN( aValue ) > 0
                     aDragDATA := { nHWnd, ;
                                    aValue, ;
                                    xCellValue, ;
                                    { cFormName, cCtrlName }, ;
                                    { nGridRow, nGridCol }, ;
                                    nWParam, ;
                                    .F. }
                     //store drag data:
                     //[1] handle of grid "from"
                     //[2] row data
                     //[3] cell data
                     //[4] Form and Control from name
                     //[5] cell dragged
                     //[6] nWParam (Left OR Right Button Dragged)
                     //[7] Drag Header
                  ELSE
                     HMG_Release_DaD()
                     aDragDATA := Nil
                     BT_BitmapRelease( hBitmap )
                     RETURN Nil
                  ENDIF

               CASE cCtrlType == 'TEXT' .OR. cCtrlType == 'NUMTEXT' .OR. cCtrlType == 'MASKEDTEXT' .OR. cCtrlType == 'CHARMASKTEXT' .OR. cCtrlType == 'EDIT'                                                      //TEXTBOX / EDITBOX
                  IF NumAnd( nWParam, MK_LBUTTON ) == MK_LBUTTON      //Left button not supported for this controls
                     HMG_Release_DaD()
                     aDragDATA := Nil
                     RETURN Nil
                  ENDIF

                  hBitmap := BT_BitmapCaptureClientArea( cFormName, ;
                                                         GetProperty( cFormName, cCtrlName, 'Row' ), ;
                                                         GetProperty( cFormName, cCtrlName, 'Col' ), ;
                                                         IF( GetProperty( cFormName, cCtrlName, 'Width' ) > 100, 100, GetProperty( cFormName, cCtrlName, 'Width' ) ), ;
                                                         IF( GetProperty( cFormName, cCtrlName, 'Height' ) > 25, 25, GetProperty( cFormName, cCtrlName, 'Height' ) ) )

                  AADD( aValue, { GetProperty( cFormName, cCtrlName, "Value" ) } )
                  aDragDATA := { nHWnd, ;
                                 aValue, ;
                                 aValue[ 1 ] [ 1 ], ;
                                 { cFormName, cCtrlName }, ;
                                 Nil, ;
                                 nWParam, ;
                                 .F. }
                  //store drag data:
                  //[1] handle of control "from"
                  //[2] value as array
                  //[3] xvalue
                  //[4] Form and Control from name
                  //[5] Nil
                  //[6] nWParam (Left OR Right Button Dragged)
                  //[7] Drag Header

               CASE cCtrlType == 'RICHEDIT'                           //EDITBOX
                  IF NumAnd( nWParam, MK_LBUTTON ) == MK_LBUTTON      //Left button not supported for this controls
                     HMG_Release_DaD()
                     aDragDATA := Nil
                     RETURN Nil
                  ENDIF

                  hBitmap := BT_BitmapCaptureClientArea( cFormName, ;
                                                         GetProperty( cFormName, cCtrlName, 'Row' ), ;
                                                         GetProperty( cFormName, cCtrlName, 'Col' ), ;
                                                         IF( GetProperty( cFormName, cCtrlName, 'Width' ) > 100, 100, GetProperty( cFormName, cCtrlName, 'Width' ) ), ;
                                                         IF( GetProperty( cFormName, cCtrlName, 'Height' ) > 25, 25, GetProperty( cFormName, cCtrlName, 'Height' ) ) )

                  IF EMPTY( GetProperty( cFormName, cCtrlName, "GetSelectText" ) )
                     //Drag entire value
                     AADD( aValue, { GetProperty( cFormName, cCtrlName, "Value" ) } )
                  ELSE
                     //Drag selected text
                     AADD( aValue, { GetProperty( cFormName, cCtrlName, "GetSelectText" ) } )
                  ENDIF

                  aDragDATA := { nHWnd, ;
                                 aValue, ;
                                 aValue[ 1 ] [ 1 ], ;
                                 { cFormName, cCtrlName }, ;
                                 Nil, ;
                                 nWParam, ;
                                 .F. }
                  //store drag data:
                  //[1] handle of control "from"
                  //[2] value
                  //[3] GetSelectText
                  //[4] Form and Control from name
                  //[5] Nil
                  //[6] nWParam (Left OR Right Button Dragged)
                  //[7] Drag Header

               CASE cCtrlType == 'LIST' .OR. cCtrlType == 'MULTILIST'                                                                       //LISTBOX
                  IF NumAnd( nWParam, MK_LBUTTON ) == MK_LBUTTON .OR. ;                                                                     //Left button not supported for this controls
                             IF( cCtrlType == 'MULTILIST', LEN( GetProperty( cFormName, cCtrlName, "Value" ) ) == 0, GetProperty( cFormName, cCtrlName, "Value" ) == 0 )                                          //no item selected
                     HMG_Release_DaD()
                     aDragDATA := Nil
                     RETURN Nil
                  ENDIF

                  IF cCtrlType == 'MULTILIST'
                     FOR i = 1 TO LEN( GetProperty( cFormName, cCtrlName, "Value" ) )
                        AADD( aValue, { GetProperty( cFormName, cCtrlName, "Item", GetProperty( cFormName, cCtrlName, "Value" ) [i] ) } )
                     NEXT i
                  ELSE
                     AADD( aValue, { GetProperty( cFormName, cCtrlName, "Item", GetProperty( cFormName, cCtrlName, "Value" ) ) } )
                  ENDIF

                  aDragDATA := { nHWnd, ;
                                 aValue, ;
                                 aValue[ 1 ] [ 1 ], ;
                                 { cFormName, cCtrlName }, ;
                                 Nil, ;
                                 nWParam, ;
                                 .F. }
                  //store drag data:
                  //[1] handle of control "from"
                  //[2] array of selectet values
                  //[3] first/alone selected value
                  //[4] Form and Control from name
                  //[5] Nil
                  //[6] nWParam (Left OR Right Button Dragged)
                  //[7] Drag Header

                  //*hBitmap := BT_BitmapCaptureDesktop (GetCursorPos()[ 1 ] - 10 , GetCursorPos()[ 2 ] - 30 , 100 , 40)  //capture dragged pointer position
                  hBitmap := BT_BitmapCreateNew( 100, LEN( aValue ) * 17, { 250, 250, 250 } )                                               //make a list of dragged items
                  //BT_DrawText (hDC, Row, Col, cText, cFontName, nFontSize, aFontColor, aBackColor, nTypeText, nAlingText, nOrientation)
                  hDC := BT_CreateDC( hBitmap, BT_HDC_BITMAP, @BTstruct )
                  FOR i = 1 TO LEN( aValue )
                     BT_DrawText( hDC, ( ( i - 1 ) * 17 ) + 1, 2, aValue[ i ] [ 1 ], "MS Shell Dlg", 9 )
                  NEXT i
                  BT_DeleteDC( BTstruct )

               CASE cCtrlType == 'TREE'                               //TREE

                  nhItemMouseOver := TREEVIEW_HITTEST( nHWnd, GetCursorRow() - GetWindowRow( nHWnd ), GetCursorCol() - GetWindowCol( nHWnd ) )
                  IF nhItemMouseOver == 0                             //mouse pointer is not over any item
                     HMG_Release_DaD()
                     aDragDATA := Nil
                     RETURN Nil
                  ENDIF

                  nTreeValue := _GetTreeItemValue( cCtrlName, cFormName, nhItemMouseOver )

                  AADD( aValue, { nTreeValue, GetProperty( cFormName, cCtrlName, "Item", nTreeValue ) } )

                  aDragDATA := { nHWnd, ;
                                 aValue, ;
                                 aValue[ 1 ] [ 1 ], ;
                                 { cFormName, cCtrlName }, ;
                                 Nil, ;
                                 nWParam, ;
                                 .F. }
                  //store drag data:
                  //[1] handle of control "from"
                  //[2] array {nValue, cItem}
                  //[3] drag tree nValue
                  //[4] Form and Control from name
                  //[5] Nil
                  //[6] nWParam (Left OR Right Button Dragged)
                  //[7] Drag Header

                  aRect := TreeView_GetItemRect( nHWnd, nhItemMouseOver )
                  hBitmap := BT_BitmapCaptureClientArea( cFormName, GetProperty( cFormName, cCtrlName, 'Row' ) + aRect[ 1 ], GetProperty( cFormName, cCtrlName, 'Col' ) + aRect[ 2 ], aRect[ 3 ], aRect[ 4 ] )

            ENDCASE

            IF isWindowDefined( _HMG_Drag_Form_ ) .AND. aDragDATA <> Nil
               SetProperty( '_HMG_Drag_Form_', 'Row', GetCursorPos() [ 1 ] + 5 )
               SetProperty( '_HMG_Drag_Form_', 'Col', GetCursorPos() [ 2 ] + 5 )
               //hDC := BT_CreateDC (hBitmap, BT_HDC_BITMAP, @BTstruct)
               //BT_DeleteDC (BTstruct)
               BT_HMGSetImage( '_HMG_Drag_Form_', '_HMD_Drag_Image_', hBitmap, .T. )
               SetProperty( '_HMG_Drag_Form_', 'WIDTH', BT_BitmapWidth( hBitmap ) )
               SetProperty( '_HMG_Drag_Form_', 'HEIGHT', BT_BitmapHeight( hBitmap ) )
               DoMethod( '_HMG_Drag_Form_', 'Show' )
            ENDIF
            BT_BitmapRelease( hBitmap )

            RETURN 1

            //stored drag data and released left/right button on grid header
         CASE VALTYPE( aDragDATA ) == "A" .AND. aDragDATA[ 7 ] .AND. ;
                          nMsg == IF( NumAnd( aDragDATA[ 6 ], MK_LBUTTON ) == MK_LBUTTON, WM_LBUTTONUP, WM_RBUTTONUP ) .AND. ;
                          ( cHeaderType == 'GRID' .OR. cHeaderType == 'MULTIGRID' )

            IF isWindowDefined( _HMG_Drag_Form_ )
               DoMethod( '_HMG_Drag_Form_', 'Hide' )
            ENDIF

            GetControlNameByHandle( GetControlHandleByIndex( nIndexHeader ), @cCtrlName, @cFormName )

            IF HMG_ValidControlDrop( cFormName, cCtrlName )           //Control enabled to drop

               i := .F.
               IF GetProperty( cFormName, cCtrlName, 'ItemCount' ) == 0                                                                     //Empty Grid, temporary add item
                  i := .T.
                  DoMethod( cFormName, cCtrlName, 'AddItem', ARRAY( GetProperty( cFormName, cCtrlName, "ColumnCOUNT" ) ) )
               ENDIF

               aGridCellData := _GetGridCellData( nIndexHeader )      //_GetGridCellData (nIndex) /* { CellRowDropped, CellColDropped } */
               nGridRow := aGridCellData[ 1 ]                         //Row of Grid cell
               nGridCol := aGridCellData[ 2 ]                         //Col of Grid cell

               IF i                                                   //was empty grid
                  DoMethod( cFormName, cCtrlName, 'DeleteAllItems' )  //restore empty grid
               ENDIF

               _HMG_DaD_DATA[ 2 ] := .T.                              //is Drag&Drop
               _HMG_DaD_DATA[ 3 ] := aDragDATA[ 4 ] [ 1 ]             //FormName From
               _HMG_DaD_DATA[ 4 ] := aDragDATA[ 4 ] [ 2 ]             //ControlName From
               _HMG_DaD_DATA[ 5 ] := cFormName                        //FormName To
               _HMG_DaD_DATA[ 6 ] := cCtrlName                        //ControlName To
               _HMG_DaD_DATA[ 7 ] := aDragDATA[ 2 ]                   //row data
               _HMG_DaD_DATA[ 8 ] := aDragDATA[ 3 ]                   //cell data
               _HMG_DaD_DATA[ 9 ] := { nGridRow, nGridCol }           //Cell dropped
               _HMG_DaD_DATA[ 10 ] := aDragDATA[ 5 ]                  //Cell dragged
               _HMG_DaD_DATA[ 11 ] := aDragDATA[ 6 ]                  //Dragged with witch button
               _HMG_DaD_DATA[ 12 ] := aDragDATA[ 7 ]                  //is grid header dragged/dropped

               _DoControlEventProcedure( _HMG_SYSDATA[ 11 ] [ nIndexHeader ], nIndexHeader )

            ENDIF

            HMG_Release_DaD()
            aDragDATA := Nil                                          //release drag data
            FOR EACH i IN aCursorChng
               SetWindowCursor( i, IDC_ARROW )                        //reastore all changed mouse cursor
            NEXT
            aCursorChng := {}
            RETURN 1

            //stored drag data and released left/right button on other supported control (not a grid header)
         CASE VALTYPE( aDragDATA ) == "A" .AND. !aDragDATA[ 7 ] .AND. ;
                          nMsg == IF( NumAnd( aDragDATA[ 6 ], MK_LBUTTON ) == MK_LBUTTON, WM_LBUTTONUP, WM_RBUTTONUP ) .AND. EMPTY( cHeaderType )

            IF isWindowDefined( _HMG_Drag_Form_ )
               DoMethod( '_HMG_Drag_Form_', 'Hide' )
            ENDIF

            GetControlNameByHandle( nHWnd, @cCtrlName, @cFormName )

            IF HMG_ValidControlDrop( cFormName, cCtrlName )           //Control enabled to drop

               aGridCellData := _GetGridCellData( nIndex )            //_GetGridCellData (nIndex) /* { CellRowDropped, CellColDropped } */
               nGridRow := aGridCellData[ 1 ]                         //Row of Grid cell
               nGridCol := aGridCellData[ 2 ]                         //Col of Grid cell

               _HMG_DaD_DATA[ 2 ] := .T.                              //is Drag&Drop
               _HMG_DaD_DATA[ 3 ] := aDragDATA[ 4 ] [ 1 ]             //FormName From
               _HMG_DaD_DATA[ 4 ] := aDragDATA[ 4 ] [ 2 ]             //ControlName From
               _HMG_DaD_DATA[ 5 ] := cFormName                        //FormName To
               _HMG_DaD_DATA[ 6 ] := cCtrlName                        //ControlName To
               _HMG_DaD_DATA[ 7 ] := aDragDATA[ 2 ]                   //row data
               _HMG_DaD_DATA[ 8 ] := aDragDATA[ 3 ]                   //cell data / tree nValue
               IF cCtrlType == "GRID" .OR. cCtrlType == "MULTIGRID"
                  _HMG_DaD_DATA[ 9 ] := { nGridRow, nGridCol }        //Cell dropped
               ENDIF
               IF cCtrlType == "TREE"
                  TreeView_SetInsertMark( nHWnd, NIL, .T. )
                  //TreeView_SelectDropTarget(nHWnd, NIL)
                  IF VALTYPE( _HMG_SYSDATA[ 40 ] [ nIndex ] [ 2 ] /* DynamicForeColor */ ) == "B"
                     TreeView_Select( nHWnd, NIL, TVGN_CARET )
                  ELSE
                     TreeView_Select( nHWnd, NIL, TVGN_DROPHILITE )   //TVGN_DROPHILITE don't works with defined DynamicForeColor
                  ENDIF
                  nhItemMouseOver := TREEVIEW_HITTEST( nHWnd, GetCursorRow() - GetWindowRow( nHWnd ), GetCursorCol() - GetWindowCol( nHWnd ) )
                  //Allow to move into empty place (empty tree)
                  // IF  nhItemMouseOver == 0  .AND. GetProperty( cFormName, cCtrlName, "ItemCount") > 0   //mouse pointer is not over any item and not empty tree
                  //   HMG_Release_DaD()
                  //   aDragDATA := Nil                          //release drag data
                  //   FOR EACH i IN aCursorChng
                  //      SetWindowCursor ( i, IDC_ARROW)              //reastore all changed mouse cursor
                  //   NEXT
                  //   aCursorChng:={}
                  //   RETURN 1
                  // ENDIF

                  nTreeValue := _GetTreeItemValue( cCtrlName, cFormName, nhItemMouseOver )

                  //_HMG_DaD_DATA [9] := { nTreeValue, GetProperty( cFormName, cCtrlName, "Item" , nTreeValue )} )
                  _HMG_DaD_DATA[ 9 ] := nTreeValue                    //identyfikator pozycji drzewa, na ktorym upuszczono wskaznik myszy
               ENDIF
               _HMG_DaD_DATA[ 10 ] := aDragDATA[ 5 ]                  //Cell dragged
               _HMG_DaD_DATA[ 11 ] := aDragDATA[ 6 ]                  //Dragged with witch button

               DO CASE
                  CASE ( cCtrlType == "GRID" .OR. cCtrlType == "MULTIGRID" ) .AND. NumAnd( _HMG_DaD_DATA[ 11 ], MK_RBUTTON ) == MK_RBUTTON
                     Ret := Nil                                       //if dragged with Right Button process other event ex. context menu
                     DoMethod( cFormName, cCtrlName, "SetFocus" )
                  CASE cCtrlType == "TREE" .AND. NumAnd( _HMG_DaD_DATA[ 11 ], MK_RBUTTON ) == MK_RBUTTON
                     Ret := Nil                                       //if dragged with Right Button process other event ex. context menu
                     _DoControlEventProcedure( _HMG_SYSDATA[ 11 ] [ nIndex ], nIndex )
                  OTHER
                     Ret := 1                                         //stop processing other events
                     _DoControlEventProcedure( _HMG_SYSDATA[ 11 ] [ nIndex ], nIndex )
               ENDCASE
            ENDIF
            HMG_Release_DaD()
            aDragDATA := Nil                                          //release drag data
            FOR EACH i IN aCursorChng
               SetWindowCursor( i, IDC_ARROW )                        //reastore all changed mouse cursor
            NEXT
            aCursorChng := {}
            RETURN Ret

            // CASE nMsg == WM_MOUSEMOVE .AND. nWParam # MK_LBUTTON .AND. nWParam # MK_RBUTTON .AND. VALTYPE(aDragDATA) == "A"  //canceled drag
         CASE nMsg == WM_MOUSEMOVE .AND. NumAnd( nWParam, MK_LBUTTON + MK_RBUTTON ) == 0 .AND. VALTYPE( aDragDATA ) == "A"                  //canceled drag

            IF isWindowDefined( _HMG_Drag_Form_ )
               DoMethod( '_HMG_Drag_Form_', 'Hide' )
            ENDIF
            HMG_Release_DaD()
            aDragDATA := Nil                                          //release drag data
            FOR EACH i IN aCursorChng
               SetWindowCursor( i, IDC_ARROW )                        //reastore all changed mouse cursor
            NEXT
            aCursorChng := {}
            RETURN 1

      ENDCASE
   ENDIF
   nLastMsg := EventMSG()
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function HMG_ValidControlTypeDragAndDrop()
*+
*+    Called from ( dragdrop.prg )   2 - function _hmg_draganddrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_ValidControlTypeDragAndDrop( cCtrlType )

RETURN cCtrlType == 'GRID' .OR. cCtrlType == 'MULTIGRID' .OR. cCtrlType == 'EDIT' .OR. cCtrlType == 'LIST' .OR. ;
        cCtrlType == 'MULTILIST' .OR. cCtrlType == 'RICHEDIT' .OR. cCtrlType == 'TEXT' .OR. cCtrlType == 'NUMTEXT' .OR. ;
        cCtrlType == 'MASKEDTEXT' .OR. cCtrlType == 'CHARMASKTEXT' .OR. cCtrlType == 'TREE'

*+--------------------------------------------------------------------
*+
*+    Function HMG_ValidControlDrag()
*+
*+    Called from ( dragdrop.prg )   2 - function _hmg_draganddrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_ValidControlDrag( cFormName, cControlName )

LOCAL nPos, lValid := .F.
   DEFAULT cFormName := ""
   DEFAULT cControlName := ""
   cFormName := UPPER( cFormName )
   cControlName := UPPER( cControlName )

   IF hb_IsArray( _HMG_DaD_DATA ) .AND. !EMPTY( cFormName ) .AND. !EMPTY( cControlName )
      IF !hb_IsArray( _HMG_DaD_DATA[ 13 ] )
         _HMG_DaD_DATA[ 13 ] := {}
      ENDIF
      lValid := ASCAN( _HMG_DaD_DATA[ 13 ], { | x | x[ 1 ] == cFormName .AND. x[ 2 ] == cControlName } ) > 0
   ENDIF
RETURN lValid

*+--------------------------------------------------------------------
*+
*+    Function HMG_ValidControlDrop()
*+
*+    Called from ( dragdrop.prg )   4 - function _hmg_draganddrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_ValidControlDrop( cFormName, cControlName )

LOCAL nPos, lValid := .F.
   DEFAULT cFormName := ""
   DEFAULT cControlName := ""
   cFormName := UPPER( cFormName )
   cControlName := UPPER( cControlName )

   IF hb_IsArray( _HMG_DaD_DATA ) .AND. !EMPTY( cFormName ) .AND. !EMPTY( cControlName )
      IF !hb_IsArray( _HMG_DaD_DATA[ 14 ] )
         _HMG_DaD_DATA[ 14 ] := {}
      ENDIF
      lValid := ASCAN( _HMG_DaD_DATA[ 14 ], { | x | x[ 1 ] == cFormName .AND. x[ 2 ] == cControlName } ) > 0
   ENDIF
RETURN lValid

*+--------------------------------------------------------------------
*+
*+    Function HMG_Is_DaD()
*+
*+    Called from ( dragdrop.prg )   1 - function hmg_dad_drag()
*+                                   1 - function hmg_dad_drop()
*+                                   1 - function hmg_dad_dropcellpos()
*+                                   1 - function hmg_dad_dragcellpos()
*+                                   1 - function hmg_dad_value()
*+                                   1 - function hmg_dad_cellvalue()
*+                                   1 - function hmg_dad_dragtreevalue()
*+                                   1 - function hmg_dad_droptreevalue()
*+                                   1 - function hmg_dad_draggridvalue()
*+                                   1 - function hmg_dad_dropgridvalue()
*+                ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_Is_DaD()

RETURN hb_IsArray( _HMG_DaD_DATA ) .AND. _HMG_DaD_DATA[ 2 ] <> Nil .AND. _HMG_DaD_DATA[ 2 ]

*+--------------------------------------------------------------------
*+
*+    Function HMG_Release_DaD()
*+
*+    Called from ( dragdrop.prg )  10 - function _hmg_draganddrop()
*+                ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_Release_DaD()

   IF hb_IsArray( _HMG_DaD_DATA )
      _HMG_DaD_DATA[ 2 ] := .F.
      _HMG_DaD_DATA[ 3 ] := Nil
      _HMG_DaD_DATA[ 4 ] := Nil
      _HMG_DaD_DATA[ 5 ] := Nil
      _HMG_DaD_DATA[ 6 ] := Nil
      _HMG_DaD_DATA[ 7 ] := Nil
      _HMG_DaD_DATA[ 8 ] := Nil
      _HMG_DaD_DATA[ 9 ] := Nil
      _HMG_DaD_DATA[ 10 ] := Nil
      _HMG_DaD_DATA[ 11 ] := Nil
      _HMG_DaD_DATA[ 12 ] := .F.
   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drag()
*+
*+    Called from ( dragdrop.prg )   1 - function hmg_dad_drag_window()
*+                                   1 - function hmg_dad_drag_control()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drag()

LOCAL cFormFrom := '', cControlFrom := ''
   IF HMG_Is_DaD() .AND. _HMG_DaD_DATA[ 3 ] <> Nil .AND. _HMG_DaD_DATA[ 4 ] <> Nil
      cFormFrom := _HMG_DaD_DATA[ 3 ]
      cControlFrom := _HMG_DaD_DATA[ 4 ]
   ENDIF
RETURN { cFormFrom, cControlFrom }

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drop()
*+
*+    Called from ( dragdrop.prg )   1 - function hmg_dad_drop_window()
*+                                   1 - function hmg_dad_drop_control()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drop()

LOCAL cFormTo := '', cControlTo := ''
   IF HMG_Is_DaD() .AND. _HMG_DaD_DATA[ 5 ] <> Nil .AND. _HMG_DaD_DATA[ 6 ] <> Nil
      cFormTo := _HMG_DaD_DATA[ 5 ]
      cControlTo := _HMG_DaD_DATA[ 6 ]
   ENDIF
RETURN { cFormTo, cControlTo }

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drag_Window()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drag_Window()

RETURN HMG_DaD_Drag() [1]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drag_Control()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drag_Control()

RETURN HMG_DaD_Drag() [2]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drop_Window()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drop_Window()

RETURN HMG_DaD_Drop() [1]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Drop_Control()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Drop_Control()

RETURN HMG_DaD_Drop() [2]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropCellPos()
*+
*+    Called from ( dragdrop.prg )   1 - function hmg_dad_dropcellrow()
*+                                   1 - function hmg_dad_dropcellcol()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropCellPos()

LOCAL nRow := Nil, nCol := Nil
   IF HMG_Is_DaD() .AND. hb_IsArray( _HMG_DaD_DATA[ 9 ] )
      nRow := _HMG_DaD_DATA[ 9 ] [ 1 ]
      nCol := _HMG_DaD_DATA[ 9 ] [ 2 ]
   ENDIF
RETURN { nRow, nCol }

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropCellRow()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropCellRow()

RETURN HMG_DaD_DropCellPos() [1]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropCellCol()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropCellCol()

RETURN HMG_DaD_DropCellPos() [2]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragCellPos()
*+
*+    Called from ( dragdrop.prg )   1 - function hmg_dad_dragcellrow()
*+                                   1 - function hmg_dad_dragcellcol()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragCellPos()

LOCAL nRow := Nil, nCol := Nil
   IF HMG_Is_DaD() .AND. hb_IsArray( _HMG_DaD_DATA[ 10 ] )
      nRow := _HMG_DaD_DATA[ 10 ] [ 1 ]
      nCol := _HMG_DaD_DATA[ 10 ] [ 2 ]
   ENDIF
RETURN { nRow, nCol }

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragCellRow()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragCellRow()

RETURN HMG_DaD_DragCellPos() [1]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragCellCol()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragCellCol()

RETURN HMG_DaD_DragCellPos() [2]

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_Value()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_Value()

LOCAL xValue := Nil
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 7 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_CellValue()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_CellValue()

LOCAL xValue := Nil
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 8 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragTreeValue()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragTreeValue()

LOCAL xValue := 0
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 8 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropTreeValue()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropTreeValue()

LOCAL xValue := 0
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 9 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragGridValue()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragGridValue()

LOCAL xValue := 0
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 8 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropGridValue()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropGridValue()

LOCAL xValue := 0
   IF HMG_Is_DaD()
      xValue := _HMG_DaD_DATA[ 9 ]
   ENDIF
RETURN xValue

*+--------------------------------------------------------------------
*+
*+    Function HMG_Is_RButtonDaD()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_Is_RButtonDaD()

RETURN hb_IsArray( _HMG_DaD_DATA ) .AND. _HMG_DaD_DATA[ 11 ] <> Nil .AND. NumAnd( _HMG_DaD_DATA[ 11 ], MK_RBUTTON ) == MK_RBUTTON           //Dragged with Right Button

*+--------------------------------------------------------------------
*+
*+    Function HMG_Is_GridHeaderDaD()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_Is_GridHeaderDaD()

RETURN hb_IsArray( _HMG_DaD_DATA ) .AND. _HMG_DaD_DATA[ 12 ] <> Nil .AND. _HMG_DaD_DATA[ 12 ]

*+--------------------------------------------------------------------
*+
*+    Function HMG_Is_ShiftDaD()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_Is_ShiftDaD()

RETURN hb_IsArray( _HMG_DaD_DATA ) .AND. _HMG_DaD_DATA[ 11 ] <> Nil .AND. NumAnd( _HMG_DaD_DATA[ 11 ], MK_SHIFT ) == MK_SHIFT               //Dragged with Shift Button

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DragControlEnable()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DragControlEnable( cFormName, cControlName, lEnable )

LOCAL nPos
   DEFAULT cFormName := ""
   DEFAULT cControlName := ""
   DEFAULT lEnable := .T.
   cFormName := UPPER( cFormName )
   cControlName := UPPER( cControlName )

   IF hb_IsArray( _HMG_DaD_DATA ) .AND. !EMPTY( cFormName ) .AND. !EMPTY( cControlName )
      IF !hb_IsArray( _HMG_DaD_DATA[ 13 ] )
         _HMG_DaD_DATA[ 13 ] := {}
      ENDIF
      nPos := ASCAN( _HMG_DaD_DATA[ 13 ], { | x | x[ 1 ] == cFormName .AND. x[ 2 ] == cControlName } )
      IF nPos = 0 .AND. lEnable
         AADD( _HMG_DaD_DATA[ 13 ], { cFormName, cControlName } )
      ENDIF
      IF nPos > 0 .AND. !lEnable
         hb_ADel( _HMG_DaD_DATA[ 13 ], nPos, .T. )
      ENDIF
   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function HMG_DaD_DropControlEnable()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_DaD_DropControlEnable( cFormName, cControlName, lEnable )

LOCAL nPos
   DEFAULT cFormName := ""
   DEFAULT cControlName := ""
   DEFAULT lEnable := .T.
   cFormName := UPPER( cFormName )
   cControlName := UPPER( cControlName )

   IF hb_IsArray( _HMG_DaD_DATA ) .AND. !EMPTY( cFormName ) .AND. !EMPTY( cControlName )
      IF !hb_IsArray( _HMG_DaD_DATA[ 14 ] )
         _HMG_DaD_DATA[ 14 ] := {}
      ENDIF
      nPos := ASCAN( _HMG_DaD_DATA[ 14 ], { | x | x[ 1 ] == cFormName .AND. x[ 2 ] == cControlName } )
      IF nPos = 0 .AND. lEnable
         AADD( _HMG_DaD_DATA[ 14 ], { cFormName, cControlName } )
      ENDIF
      IF nPos > 0 .AND. !lEnable
         hb_ADel( _HMG_DaD_DATA[ 14 ], nPos, .T. )
      ENDIF
   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function _GetTreeItemValue()
*+
*+    Called from ( dragdrop.prg )   2 - function _hmg_draganddrop()
*+
*+--------------------------------------------------------------------
*+
FUNCTION _GetTreeItemValue( ControlName, ParentForm, nItemHandle )

LOCAL retval, T, c, ix

   retval := 0

   T := GetControlType( ControlName, ParentForm )
   c := GetControlHandle( ControlName, ParentForm )
   ix := GetControlIndex( ControlName, ParentForm )

   IF T == "TREE"
      retval := ASCAN( _HMG_SYSDATA[ 7 ] [ ix ], nItemHandle )

      IF _HMG_SYSDATA[ 9 ] [ ix ] == .T. .AND. retval > 0 .AND. retval <= LEN( _HMG_SYSDATA[ 25 ] [ ix ] )
         retval := _HMG_SYSDATA[ 25 ] [ ix ] [ retval ]
      ENDIF

   ENDIF
RETURN ( retval )

*+--------------------------------------------------------------------
*+
*+    Function _IsTreeItemIDs()
*+
*+--------------------------------------------------------------------
*+
FUNCTION _IsTreeItemIDs( ControlName, ParentForm )

   //Check if the tree uses the ID's instead of the position number
LOCAL retval := .F.
   IF GetControlType( ControlName, ParentForm ) == "TREE"
      retval := _HMG_SYSDATA[ 9 ] [ GetControlIndex( ControlName, ParentForm ) ]
   ENDIF
RETURN ( retval )

*+--------------------------------------------------------------------
*+
*+    Function _InsertItem()
*+
*+--------------------------------------------------------------------
*+
FUNCTION _InsertItem( ControlName, ParentForm, Value, nInsertPos, aImage, Id )

LOCAL t, c, NewHandle, TempHandle, i, ix, aPos, ChildHandle, BackHandle, ParentHandle
LOCAL TreeItemHandle                                                  // Tree+
LOCAL ImgDef, iUnSel, iSel, xRet

   ix := GetControlIndex( ControlName, ParentForm )

   T = _HMG_SYSDATA[ 1 ] [ ix ]

   c = _HMG_SYSDATA[ 3 ] [ ix ]

   IF VALTYPE( Id ) == 'U'
      Id := 0
   ENDIF

   IF VALTYPE( aImage ) == 'N'
      Id := aImage
   ENDIF

   DO CASE
      CASE T == "TREE"

         IF _HMG_SYSDATA[ 9 ] [ ix ] == .F.

            IF nInsertPos > TreeView_GetCount( c ) .OR. nInsertPos < 0
               MsgHMGError( "InsItem Method:  Invalid InsertPos Value. Program Terminated" )
            ENDIF

         ENDIF

         ImgDef := IIF( VALTYPE( aImage ) == "A", HMG_LEN( aImage ), 0 )                                                                    //Tree+

         IF nInsertPos != 0

            IF _HMG_SYSDATA[ 9 ] [ ix ] == .F.
               TreeItemHandle := _HMG_SYSDATA[ 7 ] [ ix ] [ nInsertPos ]
            ELSE
               aPos := ASCAN( _HMG_SYSDATA[ 25 ] [ ix ], nInsertPos )

               IF aPos == 0
                  MsgHMGError( "InsItem Method: Invalid InsertPos Value. Program Terminated" )
               ENDIF
               nInsertPos := aPos
               TreeItemHandle := _HMG_SYSDATA[ 7 ] [ ix ] [ aPos ]

            ENDIF

            IF ImgDef == 0

               iUnsel := 2                                            // Pointer to defalut Node Bitmaps, no Bitmap loaded
               iSel := 3
            ELSE
               iUnSel := AddTreeViewBitmap( c, aImage[ 1 ], _HMG_SYSDATA[ 39 ] [ ix ] ) - 1
               iSel := IIF( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[ 2 ], _HMG_SYSDATA[ 39 ] [ ix ] ) - 1 )
               // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
            ENDIF

            NewHandle := InsTreeItem( c, TreeItemHandle, Value, iUnsel, iSel, Id, _IS_TREE_ITEM_ )

            //  Determine Position of New Item

            TempHandle := TreeView_GetChild( c, TreeItemHandle )
            IF TempHandle == 0                                        //get no child, seek next sibling
               TempHandle := TreeView_GetNextSibling( c, TreeItemHandle )
            ENDIF

            i := 0

            DO WHILE .t.

               i ++

               IF TempHandle == NewHandle
                  EXIT
               ENDIF

               ChildHandle := TreeView_GetChild( c, TempHandle )

               IF ChildHandle == 0
                  BackHandle := TempHandle
                  TempHandle := TreeView_GetNextSibling( c, TempHandle )
               ELSE
                  i ++
                  BackHandle := Childhandle
                  TempHandle := TreeView_GetNextSibling( c, ChildHandle )
               ENDIF

               DO WHILE TempHandle == 0

                  ParentHandle := TreeView_GetParent( c, BackHandle )

                  TempHandle := TreeView_GetNextSibling( c, ParentHandle )

                  IF TempHandle == 0
                     BackHandle := ParentHandle
                  ENDIF

               ENDDO

            ENDDO

            //  Insert New Element

            IF _HMG_SYSDATA[ 9 ] [ ix ] == .T. .AND. ASCAN( _HMG_SYSDATA[ 25 ] [ ix ], Id ) != 0
               MsgHMGError( "InsItem Method:  Item Id " + ALLTRIM( STR( Id ) ) + " Already In Use. Program Terminated" )
            ENDIF

            xRet := nInsertPos + i

            hb_AIns( _HMG_SYSDATA[ 7 ] [ ix ], nInsertPos + i, NewHandle, .T. /* <lAutoSize> */ )                                           // nTreeItemHandle
            hb_AIns( _HMG_SYSDATA[ 25 ] [ ix ], nInsertPos + i, Id, .T. /* <lAutoSize> */ )                                                 // nId
            hb_AIns( _HMG_SYSDATA[ 32 ] [ ix ], nInsertPos + i, NIL, .T. /* <lAutoSize> */ )                                                // cargo

         ELSE

            IF ImgDef == 0

               iUnsel := 0                                            // Pointer to defalut Node Bitmaps, no Bitmap loaded
               iSel := 1
            ELSE
               iUnSel := AddTreeViewBitmap( c, aImage[ 1 ], _HMG_SYSDATA[ 39 ] [ ix ] ) - 1
               iSel := IIF( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[ 2 ], _HMG_SYSDATA[ 39 ] [ ix ] ) - 1 )
               // If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
            ENDIF

            NewHandle := InsTreeItem( c, 0, Value, iUnsel, iSel, Id, _IS_TREE_ITEM_ )

            IF _HMG_SYSDATA[ 9 ] [ ix ] == .T. .AND. ASCAN( _HMG_SYSDATA[ 25 ] [ ix ], Id ) != 0
               MsgHMGError( "InsItem Method:  Item Id " + ALLTRIM( STR( Id ) ) + " Already In Use. Program Terminated" )
            ENDIF

            AADD( _HMG_SYSDATA[ 7 ] [ ix ], NewHandle )               // nTreeItemHandle
            AADD( _HMG_SYSDATA[ 25 ] [ ix ], Id )                     // nId
            AADD( _HMG_SYSDATA[ 32 ] [ ix ], NIL )                    // cargo

            xRet := LEN( _HMG_SYSDATA[ 7 ] [ ix ] )

         ENDIF

   ENDCASE
RETURN xRet

*+ EOF: DRAGDROP.PRG
