*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\GridDuo\\GRIDDUO.PRG
*+
*+    Copyright(C) 1983-2020 by Auge & Ohr
*+
*+    Functions: Function Main()
*+               Function Drag_Grid1()
*+               Function Drag_Grid2()
*+               Function Grid_2_UpDate()
*+               Function CloneGrid()
*+               Function HMG_GetGridAllItems()
*+               Function HMG_GetGridRowItems()
*+
*+    Reformatted by Click! 2.05.35 on Nov-11-2020 at 11:40 pm
*+
*+--------------------------------------------------------------------

#include "hmg.ch"

* MEMVAR _HMG_SYSDATA , _HMG_DAD_DATA
*+--------------------------------------------------------------------
*+
*+    Function Main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Main

LOCAL aRows[ 20 ] [ 3 ]

   EnableDragAndDrop()

   DEFINE WINDOW Form_1 ;
         AT 0, 0 ;
         WIDTH 800 ;
         HEIGHT 550 ;
         TITLE 'Hello World!' ;
         MAIN

      aRows[ 1 ] := { 'Simpson', 'Homer', '555-5555' }
      aRows[ 2 ] := { 'Mulder', 'Fox', '324-6432' }
      aRows[ 3 ] := { 'Smart', 'Max', '432-5892' }
      aRows[ 4 ] := { 'Grillo', 'Pepe', '894-2332' }
      aRows[ 5 ] := { 'Kirk', 'James', '346-9873' }
      aRows[ 6 ] := { 'Barriga', 'Carlos', '394-9654' }
      aRows[ 7 ] := { 'Flanders', 'Ned', '435-3211' }
      aRows[ 8 ] := { 'Smith', 'John', '123-1234' }
      aRows[ 9 ] := { 'Pedemonti', 'Flavio', '000-0000' }
      aRows[ 10 ] := { 'Gomez', 'Juan', '583-4832' }
      aRows[ 11 ] := { 'Fernandez', 'Raul', '321-4332' }
      aRows[ 12 ] := { 'Borges', 'Javier', '326-9430' }
      aRows[ 13 ] := { 'Alvarez', 'Alberto', '543-7898' }
      aRows[ 14 ] := { 'Gonzalez', 'Ambo', '437-8473' }
      aRows[ 15 ] := { 'Batistuta', 'Gol', '485-2843' }
      aRows[ 16 ] := { 'Vinazzi', 'Amigo', '394-5983' }
      aRows[ 17 ] := { 'Pedemonti', 'Flavio', '534-7984' }
      aRows[ 18 ] := { 'Samarbide', 'Armando', '854-7873' }
      aRows[ 19 ] := { 'Pradon', 'Alejandra', '???-????' }
      aRows[ 20 ] := { 'Reyes', 'Monica', '432-5836' }

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 200, 20

         BUTTON B_CLONE CAPTION " Clone to Grid 2 " ACTION CloneGrid()
         BUTTON B_ITEMS CAPTION " List of all items of Grid 2 " ACTION MsgDebug( HMG_GetGridAllItems( 'Form_1', 'Grid_2' ) )
         BUTTON B_CLEAN CAPTION " Clean Grid 2 " ACTION Form_1.Grid_2.DeleteAllItems

      END TOOLBAR

      @ 50, 10 GRID Grid_1 ;
              WIDTH 760 ;
              HEIGHT 180 ;
              HEADERS { 'Last Name', 'First Name', 'Phone' } ;
              WIDTHS { 140, 140, 140 } ;
              ITEMS aRows ;
              VALUE { 1, 1 } ;
              EDIT ;
              JUSTIFY { GRID_JTFY_CENTER, GRID_JTFY_RIGHT, GRID_JTFY_RIGHT } ;
              CELLNAVIGATION ;
              ON GOTFOCUS Drag_Grid1()

      @ 240, 10 GRID Grid_2 ;
              WIDTH 760 ;
              HEIGHT 180 ;
              HEADERS { 'Last Name', 'First Name', 'Phone' } ;
              WIDTHS { 140, 140, 140 } ;
              ITEMS {} ;
              VALUE 1 ;
              ON GOTFOCUS Drag_Grid2()

   END WINDOW

   HMG_DaD_DragControlEnable( 'Form_1', 'Grid_1', .T. )

   HMG_DaD_DropControlEnable( 'Form_1', 'Grid_2', .T. )

   CENTER WINDOW Form_1

   ACTIVATE WINDOW Form_1

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function Drag_Grid1()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Drag_Grid1()

LOCAL cDragFName                := HMG_DaD_Drag_Window()
LOCAL cDragCName                := HMG_DaD_Drag_Control()
LOCAL cDropFName                := HMG_DaD_Drop_Window()
LOCAL cDropCName                := HMG_DaD_Drop_Control()
LOCAL nDragGridValue            := HMG_DaD_DragGridValue()            // cell data
LOCAL nDropGridValue            := HMG_DaD_DropGridValue()            // { nGridRow , nGridCol }
LOCAL lIsDraggedWithRightButton := HMG_Is_RButtonDaD()
LOCAL lIsDraggedWithShiftButton := HMG_Is_ShiftDaD()

   IF HMG_Is_DaD()
      HMG_Release_DaD()
      DO CASE
         CASE cDragFName == cDropFName .AND. cDragFName == 'Form_1' .AND. cDragCName == cDropCName .AND. cDragCName == 'Grid_1' .AND. nDragGridValue <> nDropGridValue
            Grid_2_UpDate( cDragFName, cDragCName, nDragGridValue, cDropCName, cDropFName, nDropGridValue, HMG_VirtualKeyIsPressed( VK_LCONTROL ) .OR. HMG_VirtualKeyIsPressed( VK_RCONTROL ), !lIsDraggedWithShiftButton )

      ENDCASE
   ENDIF
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Function Drag_Grid2()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Drag_Grid2()

LOCAL cDragFName                := HMG_DaD_Drag_Window()
LOCAL cDragCName                := HMG_DaD_Drag_Control()
LOCAL cDropFName                := HMG_DaD_Drop_Window()
LOCAL cDropCName                := HMG_DaD_Drop_Control()
LOCAL nDragGridValue            := HMG_DaD_DragGridValue()            // cell data
LOCAL nDropGridValue            := HMG_DaD_DropGridValue()            // { nGridRow , nGridCol }
LOCAL lIsDraggedWithRightButton := HMG_Is_RButtonDaD()
LOCAL lIsDraggedWithShiftButton := HMG_Is_ShiftDaD()
LOCAL TEXTBOXVal                := HMG_DaD_CellValue()

   IF HMG_Is_DaD()
      HMG_Release_DaD()
      DO CASE
         CASE cDragCName == 'Grid_1' .OR. cDragCName == 'Grid_2'

            IF cDragFName == cDropFName .AND. cDragCName == cDropCName .AND. nDragGridValue = nDropGridValue
               //we do not want to be able to drag and drop the item on itself
               RETURN Nil
            ENDIF

            IF lIsDraggedWithRightButton

            ELSE
               Grid_2_UpDate( cDragFName, cDragCName, nDragGridValue, cDropCName, cDropFName, nDropGridValue, HMG_VirtualKeyIsPressed( VK_LCONTROL ) .OR. HMG_VirtualKeyIsPressed( VK_RCONTROL ), !lIsDraggedWithShiftButton )
            ENDIF
      ENDCASE

   ENDIF
RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function Grid_2_UpDate()
*+
*+    Called from ( gridduo.prg )   1 - function drag_grid1()
*+                                   1 - function drag_grid2()
*+
*+--------------------------------------------------------------------
*+
FUNCTION Grid_2_UpDate( cDragFName, cDragCName, nDragGridValue, cDropCName, cDropFName, nDropGridValue, lCopy, lAdd )

   // Local hGrid1 := GetControlHandle( cDragCName, cDragFName )
   // Local hGrid2 := GetControlHandle( cDropCName, cDropFName )
LOCAL aItem      := GetProperty( cDragFName, cDragCName, "Value" )
LOCAL aDragItems

   // get select Item
   aDragItems := _GetItem( cDragCName, cDragFName, aItem[ 1 ] )
   // ADD Item to Target
   Domethod( cDropFName, cDropCName, "AddItem", aDragItems )
   // delete Item in Source
   Domethod( cDragFName, cDragCName, "DeleteItem", aItem[ 1 ] )

   //    Domethod( cDragFName, cDragCName, "Refresh" )
   //    Domethod( cDropFName, cDropCName, "Refresh" )

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function CloneGrid()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION CloneGrid()

LOCAL i

   Form_1.Grid_2.DeleteAllItems
   FOR i = 1 TO Form_1.Grid_1.ItemCount
      Form_1.Grid_2.AddItem( HMG_GetGridRowItems( 'Form_1', 'Grid_1', i ) )
   NEXT i

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Function HMG_GetGridAllItems()
*+
*+    Called from ( gridduo.prg )   1 - function main()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_GetGridAllItems( cForm, cGrid )

LOCAL aAllItems := {}, nRow, cType
   CHECK TYPE cForm AS CHARACTER, ;
           cGrid AS CHARACTER

   IF _IsControlDefined( cGrid, cForm )
      cType := GetControlType( cGrid, cForm )
      IF cType == "GRID" .OR. cType == "MULTIGRID"
         FOR nRow = 1 TO GetProperty( cForm, cGrid, 'ItemCount' )
            AADD( aAllItems, _GetItem( cGrid, cForm, nRow ) )
         NEXT nRow
      ENDIF
   ENDIF
RETURN aAllItems

*+--------------------------------------------------------------------
*+
*+    Function HMG_GetGridRowItems()
*+
*+    Called from ( gridduo.prg )   1 - function clonegrid()
*+
*+--------------------------------------------------------------------
*+
FUNCTION HMG_GetGridRowItems( cForm, cGrid, nRow )

LOCAL aRowItems := {}, cType
   DEFAULT nRow := 1
   CHECK TYPE cForm AS CHARACTER, ;
           cGrid AS CHARACTER, ;
           nRow AS NUMERIC

   IF _IsControlDefined( cGrid, cForm )
      cType := GetControlType( cGrid, cForm )
      IF ( cType == "GRID" .OR. cType == "MULTIGRID" ) .AND. nRow > 0 .AND. nRow <= GetProperty( cForm, cGrid, 'ItemCount' )
         aRowItems := _GetItem( cGrid, cForm, nRow )
      ENDIF
   ENDIF
RETURN aRowItems

//
//

*+ EOF: GRIDDUO.PRG